const prices = [20, 25, 30, 45, 50, 90, 15];

const salePrices = prices.map((price) => { // der ursprünglichen Wert "price" wird die Preise geändert
    return price / 2;
})

console.log(salePrices);

const products = [
    { name: "gold star", price: 20 },
    { name: "mushrooms", price: 40 },
    { name: "green shells", price: 35 },
    { name: "banana skin", price: 45 },
    { name: "red shells", price: 4 }
];

const productsOn = products.map((product) => { // wenn die Preise mehr als 30 sein wird, wird die Preise im Objekt geändert, wenn der Wert der Bedienung enspricht, wird nicht nur die Preis verändert
                                            // sondern wird das ganze Objekt verändert 
    if (product.price > 30) {
        return { name: product.name, price: (product.price / 2) } // damit wird das originale Objekt nicht verändert (reference Daten)
    } else {
        return { name: product.name, price: product.price }
    }
})

console.log(productsOn)